import 'package:flutter/material.dart';

class RouteNameManager {
  static const String checkout = "/checkout";
  static const String flashSale = "/flashSale";
  static const String pc3 = "/pc3";
}

class RoutingPageType {

  final String routeName;
  Object arguments;

  RoutingPageType.checkout() : routeName = RouteNameManager.checkout;

  RoutingPageType.flashSale({@required this.arguments})
      : routeName = RouteNameManager.flashSale;

  RoutingPageType.pc3() : routeName = RouteNameManager.pc3;
}

class FlutterRoutingManager {
  static Future<T> pushTo<T extends Object>(RoutingPageType routingPageType,
      BuildContext context) {
    return Navigator.pushNamed<T>(context, routingPageType.routeName,
        arguments: routingPageType.arguments);
  }

  static Future<T> pushWithAppLink<T extends Object>(String appLink, BuildContext context) {
    if (appLink.contains("/su-kien")) {
      final routingPageType = RoutingPageType.flashSale();
      return Navigator.pushNamed<T>(context, routingPageType.routeName,
          arguments: routingPageType.arguments);
    }
    if (appLink.contains("/tien-ich")) {
      final routingPageType = RoutingPageType.pc3();
      return Navigator.pushNamed<T>(context, routingPageType.routeName,
          arguments: routingPageType.arguments);
    }
  }
}